// Defines the box - a derived shape from class Object

#ifndef __BOX_H
#define __BOX_H

#include "object.h"
#include "primitive.h"
#include "surface.h"
#include "ray.h"
#include "csg.h"

class Box : public Primitive
{
	public:
		
	Vector3D l ;
	Vector3D h ;
	Box( Surface* s, const Vector3D& low, const Vector3D& high ) ; 
	Box( const Box& ) ; // Copy constructor
	virtual bool intersect( Ray& ) ;
	virtual bool shadow_intersect( Ray& ) ;
	virtual void computeBounds( bVolume& b ) ; // Compute bounding volume for this box
	virtual Color shade( const Ray&, int depth ) ;
	virtual ~Box() {}
	
	// Compute interval list obtained by intersecting ray with sphere
	virtual vector <CSG_Interval*> compute_intervals( const Ray& ) ;
};

bool IsPointInBox( const Vector3D&, Box* ) ; 

#endif
