//Defines the plane - a derived shape from class Object

#ifndef __PLANE_H
#define __PLANE_H

#include "object.h"
#include "primitive.h"
#include "surface.h"
#include "ray.h"
#include "csg.h"

class Plane : public Primitive
{
	public:
		
	Vector3D point ;
	Vector3D normal ; // Assume that the plane includes the entire space behind it wrt the normal
	Plane( Surface* s, const Vector3D& p, const Vector3D& n ) ; 
	Plane( const Plane& ) ; // Copy constructor
	virtual bool intersect( Ray& ) ;
	virtual bool shadow_intersect( Ray& ) ;
	virtual void computeBounds( bVolume& b ) ; // Compute bounding volume for this plane - Shady
	virtual Color shade( const Ray&, int depth ) ;
	virtual ~Plane() {}
	
	// Compute interval list obtained by intersecting ray with sphere
	virtual vector <CSG_Interval*> compute_intervals( const Ray& ) ;
};

#endif
