// Defines the sphere - a derived shape from class object

#ifndef __SPHERE_H
#define __SPHERE_H

#include "object.h"
#include "primitive.h"
#include "surface.h"
#include "ray.h"
#include "csg.h"

class Sphere : public Primitive
{
	public:
		
	Vector3D centre ; // The position vector of the centre of the sphere
	double radius ;	// The radius of the sphere    
	double radius_sq ; // Precomputed square of the radius

	Sphere( Surface* s, const Vector3D& v, double r ) ;
	Sphere( const Sphere& ) ; // Copy constructor
	virtual bool intersect( Ray& ) ;
	virtual bool shadow_intersect( Ray& ) ; // Specially to save time for shadow rays 
	virtual void computeBounds( bVolume& b ) ; // Compute bounding volume for this sphere
	virtual Color shade( const Ray&, int depth ) ;
	virtual ~Sphere() {}
	
	// Compute interval list obtained by intersecting ray with sphere
	virtual vector <CSG_Interval*> compute_intervals( const Ray& ) ;
};

#endif
