/*
 * texture.h - Definitions and global variables/declarations for texture mapping
 */

#ifndef __TEXTURE_H
#define __TEXTURE_H

#include "ppm.h"	// For using ppm images in textures
#include "color.h"  // Need to know about colors :)

// Filtering modes allowed for texture mapping
#define NO_FILTER 0
#define BILINEAR_FILTER 1

// PPM Channels
#define RED_CHANNEL 0
#define GREEN_CHANNEL 1
#define BLUE_CHANNEL 2

class Texture {
	
	public:
	/*
	 * The ppm Image structure used to store the texture in memory
	 * See ppm.h for details
	 */
	Image* textureMap ;
	
	/*
	 * Loads the texture from the specified ppm file
	 */
	void loadFromPPM( char* TextureFileName ) ;
	
	/*
	 * The principal function used in texture mapping
 	 * Method to return Color of a texture map at a point ( u, v )
 	 */
	Color map( double u, double v, int filter = NO_FILTER ) ;
};

#endif
