// Class declaration for 3D vectors - vector3D.h

#ifndef __VECTOR3D_H
#define __VECTOR3D_H

/* Wrapper C struct defined later */
struct __wrap_Vector3D ;

class Vector3D {
    public :
	
	double x, y, z;

    // constructors
    Vector3D( ) { x = y = z = 0 ; }
    Vector3D(double x, double y, double z);
    Vector3D(const Vector3D &v);
    Vector3D(const __wrap_Vector3D &v );

    // methods
    double dot(const Vector3D &B) const;                         // this with B
    double dot(double Bx, double By, double Bz) const;       // B spelled out
    //double dot(Vector3D A, Vector3D B);      // A dot B
    
    Vector3D cross(const Vector3D &B) const;                    // this with B
    Vector3D cross(double Bx, double By, double Bz) const;  // B spelled out
    //static Vector3D cross(Vector3D A, Vector3D B); // A cross B

    double length( ) const;                               // of this
    static double length(const Vector3D &A);               // of A

    void normalize( );                             // makes this unit length
    static Vector3D normalize(const Vector3D &A);         // makes A unit length

};

#endif
