/* wrappers.h - Contains some C wrapper structures for the ray tracer C++ classes so that yacc can use them properly
 */

#ifndef __WRAPPERS_H
#define __WRAPPERS_H

#include "vector3D.h"
#include "color.h"
#include "csg.h"

// Transformation type definitions
#define TRANSLATE_TRANSFORMATION 0
#define SCALE_TRANSFORMATION     1
#define ROTATE_TRANSFORMATION	 2

struct __wrap_Vector3D {
	double x, y, z ;
};

struct __wrap_Color {
	double red, green, blue ; 
};

struct __wrap_transformation {
	int type ; // Whether translation or scaling or rotation
	double x,y,z ; // Only for translation, scaling
	double theta ; // Only for rotations
	char axis ; // Only for rotations
};

struct __wrap_marker {
	int start ;
	bool isPrimitive[ MAX_CSG_LIST_SIZE ] ; // Chain up list of primitives vs non-primitives
	int length ; // Length of list of objects
};

#endif
